Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1932)
+++ palm/trunk/SOURCE/Makefile	(revision 1933)
@@ -312,7 +312,7 @@
 	mod_particle_attributes.f90 netcdf_interface_mod.f90 nudging_mod.f90 \
 	package_parin.f90 palm.f90 parin.f90 plant_canopy_model_mod.f90 pmc_interface_mod.f90 \
-	pmc_client_mod.f90 pmc_general_mod.f90 pmc_handle_communicator_mod.f90 \
-	pmc_mpi_wrapper_mod.f90 pmc_server_mod.f90 poisfft_mod.f90 poismg_mod.f90 \
-	poismg_noopt.f90 pres.f90 print_1d.f90 production_e.f90 \
+	pmc_child_mod.f90 pmc_general_mod.f90 pmc_handle_communicator_mod.f90 \
+	pmc_mpi_wrapper_mod.f90 pmc_parent_mod.f90 poisfft_mod.f90 poismg.f90 \
+	poismg_fast_mod.f90 pres.f90 print_1d.f90 production_e.f90 \
 	prognostic_equations.f90 progress_bar_mod.f90 radiation_model_mod.f90 \
 	random_function_mod.f90 random_gauss.f90 random_generator_parallel_mod.f90 \
@@ -495,12 +495,12 @@
    radiation_model_mod.o microphysics_mod.o wind_turbine_model_mod.o
 plant_canopy_model_mod.o: modules.o mod_kinds.o
-pmc_interface_mod.o: modules.o mod_kinds.o pmc_client_mod.o pmc_general_mod.o\
-	pmc_handle_communicator_mod.o pmc_mpi_wrapper_mod.o pmc_server_mod.o
-pmc_client_mod.o: mod_kinds.o pmc_general_mod.o pmc_handle_communicator_mod.o\
+pmc_interface_mod.o: modules.o mod_kinds.o pmc_child_mod.o pmc_general_mod.o\
+	pmc_handle_communicator_mod.o pmc_mpi_wrapper_mod.o pmc_parent_mod.o
+pmc_child_mod.o: mod_kinds.o pmc_general_mod.o pmc_handle_communicator_mod.o\
    pmc_mpi_wrapper_mod.o
 pmc_general_mod.o: mod_kinds.o
 pmc_handle_communicator_mod.o: modules.o mod_kinds.o pmc_general_mod.o
 pmc_mpi_wrapper_mod.o: pmc_handle_communicator_mod.o
-pmc_server_mod.o: pmc_general_mod.o pmc_handle_communicator_mod.o pmc_mpi_wrapper_mod.o
+pmc_parent_mod.o: pmc_general_mod.o pmc_handle_communicator_mod.o pmc_mpi_wrapper_mod.o
 poisfft_mod.o: modules.o cpulog_mod.o fft_xy_mod.o mod_kinds.o tridia_solver_mod.o
 poismg_mod.o: modules.o cpulog_mod.o mod_kinds.o
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1932)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1933)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-!
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1823 2016-04-07 08:57:52Z hoffmann
+! Initial version of purely vertical nesting introduced.
 !
 ! 1822 2016-04-07 07:49:42Z hoffmann
@@ -159,4 +162,7 @@
     USE pegrid
 
+    USE pmc_interface,                                                         &
+        ONLY : nesting_mode
+
 
     IMPLICIT NONE
@@ -359,12 +365,13 @@
 !
 !-- The same restoration for u at i=nxl and v at j=nys as above must be made
-!-- in case of nest boundaries. Note however, that the above ELSEIF-structure is
-!-- not appropriate here as there may be more than one nest boundary on a
-!-- PE-domain. Furthermore Neumann conditions for SGS-TKE are not required here.
-    IF ( nest_bound_s )  THEN
-       v_p(:,nys,:) = v_p(:,nys-1,:)
-    ENDIF
-    IF ( nest_bound_l )  THEN
-       u_p(:,:,nxl) = u_p(:,:,nxl-1)
+!-- in case of nest boundaries. This must not be done in case of vertical nesting 
+!-- mode as in that case the lateral boundaries are actually cyclic.
+    IF ( nesting_mode /= 'vertical' )  THEN
+       IF ( nest_bound_s )  THEN
+          v_p(:,nys,:) = v_p(:,nys-1,:)
+       ENDIF
+       IF ( nest_bound_l )  THEN
+          u_p(:,:,nxl) = u_p(:,:,nxl-1)
+       ENDIF
     ENDIF
 
Index: palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1932)
+++ palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1933)
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1818 2016-04-06 15:53:27Z maronga
+! Initial version of purely vertical nesting introduced. 
+! 
 ! 1804 2016-04-05 16:30:18Z maronga
 ! Removed code for parameter file check (__check)
@@ -81,4 +84,8 @@
     USE pegrid
 
+    USE pmc_interface,                                                         &
+        ONLY : nesting_mode
+
+
     IMPLICIT NONE
 
@@ -160,23 +167,25 @@
 !
 !-- Neumann-conditions at inflow/outflow/nested boundaries
-    IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
-       DO  i = nbgp, 1, -1
-         ar(:,nxl-i) = ar(:,nxl)
-       ENDDO
-    ENDIF
-    IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
-       DO  i = 1, nbgp
-          ar(:,nxr+i) = ar(:,nxr)
-       ENDDO
-    ENDIF
-    IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
-       DO  i = nbgp, 1, -1
-         ar(nys-i,:) = ar(nys,:)
-       ENDDO
-    ENDIF
-    IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
-       DO  i = 1, nbgp
-         ar(nyn+i,:) = ar(nyn,:)
-       ENDDO
+    IF ( nesting_mode /= 'vertical' )  THEN
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+          DO  i = nbgp, 1, -1
+             ar(:,nxl-i) = ar(:,nxl)
+          ENDDO
+       ENDIF
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+          DO  i = 1, nbgp
+             ar(:,nxr+i) = ar(:,nxr)
+          ENDDO
+       ENDIF
+       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+          DO  i = nbgp, 1, -1
+             ar(nys-i,:) = ar(nys,:)
+          ENDDO
+       ENDIF
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+          DO  i = 1, nbgp
+             ar(nyn+i,:) = ar(nyn,:)
+          ENDDO
+       ENDIF
     ENDIF
 
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1932)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1933)
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1923 2016-05-31 16:37:07Z boeske
+! Initial version of purely vertical nesting introduced. 
+! 
 ! 1922 2016-05-31 16:36:08Z boeske
 ! Bugfix: array transposition checks restricted to cases if a fourier 
@@ -153,7 +156,7 @@
                maximum_parallel_io_streams, message_string,                    &
                mg_switch_to_pe0_level, momentum_advec, nest_bound_l,           &
-               nest_bound_n, nest_bound_r, nest_bound_s, neutral, psolver,     &
-               outflow_l, outflow_n, outflow_r, outflow_s, recycling_width,    &
-               scalar_advec, subdomain_size 
+               nest_bound_n, nest_bound_r, nest_bound_s, nest_domain, neutral, &
+               psolver, outflow_l, outflow_n, outflow_r, outflow_s,            &
+               recycling_width, scalar_advec, subdomain_size 
 
     USE grid_variables,                                                        &
@@ -170,5 +173,8 @@
       
     USE pegrid
-
+    
+    USE pmc_interface,                                                         &   
+        ONLY:  nesting_mode
+   
     USE spectra_mod,                                                           &
         ONLY:  calculate_spectra, dt_dosp
@@ -1092,46 +1098,69 @@
 #if defined( __parallel )
 !
-!-- Setting of flags for inflow/outflow/nesting conditions in case of non-cyclic
-!-- horizontal boundary conditions.
-    IF ( pleft == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation' )  THEN
-          inflow_l  = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
-          outflow_l = .TRUE.
-       ELSEIF ( bc_lr == 'nested' )  THEN
+!-- Setting of flags for inflow/outflow/nesting conditions.
+    IF ( nesting_mode == 'vertical' .AND. nest_domain )  THEN
+       IF ( nxl == 0 )  THEN
           nest_bound_l = .TRUE.
        ENDIF
-    ENDIF
-
-    IF ( pright == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation' )  THEN
-          outflow_r = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
-          inflow_r  = .TRUE.
-       ELSEIF ( bc_lr == 'nested' )  THEN
+    ELSE
+       IF ( pleft == MPI_PROC_NULL )  THEN
+          IF ( bc_lr == 'dirichlet/radiation' )  THEN
+             inflow_l  = .TRUE.
+          ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
+             outflow_l = .TRUE.
+          ELSEIF ( bc_lr == 'nested' )  THEN
+             nest_bound_l = .TRUE.
+          ENDIF
+       ENDIF
+    ENDIF
+ 
+    IF ( nesting_mode == 'vertical' .AND. nest_domain )  THEN
+       IF ( nxr == nx )  THEN
           nest_bound_r = .TRUE.
        ENDIF
-    ENDIF
-
-    IF ( psouth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
-          outflow_s = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-          inflow_s  = .TRUE.
-       ELSEIF ( bc_ns == 'nested' )  THEN
+    ELSE
+       IF ( pright == MPI_PROC_NULL )  THEN
+          IF ( bc_lr == 'dirichlet/radiation' )  THEN
+             outflow_r = .TRUE.
+          ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
+             inflow_r  = .TRUE.
+          ELSEIF ( bc_lr == 'nested' )  THEN
+             nest_bound_r = .TRUE.
+          ENDIF
+       ENDIF
+    ENDIF
+
+    IF ( nesting_mode == 'vertical' .AND. nest_domain )  THEN
+       IF ( nys == 0 )  THEN
           nest_bound_s = .TRUE.
        ENDIF
-    ENDIF
-
-    IF ( pnorth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
-          inflow_n  = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-          outflow_n = .TRUE.
-       ELSEIF ( bc_ns == 'nested' )  THEN
+    ELSE
+       IF ( psouth == MPI_PROC_NULL )  THEN
+          IF ( bc_ns == 'dirichlet/radiation' )  THEN
+             outflow_s = .TRUE.
+          ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+             inflow_s  = .TRUE.
+          ELSEIF ( bc_ns == 'nested' )  THEN
+             nest_bound_s = .TRUE.
+          ENDIF
+       ENDIF
+    ENDIF
+
+    IF ( nesting_mode == 'vertical' .AND. nest_domain )  THEN
+       IF ( nyn == ny )  THEN
           nest_bound_n = .TRUE.
        ENDIF
-    ENDIF
-
+    ELSE
+       IF ( pnorth == MPI_PROC_NULL )  THEN
+          IF ( bc_ns == 'dirichlet/radiation' )  THEN
+             inflow_n  = .TRUE.
+          ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+             outflow_n = .TRUE.
+          ELSEIF ( bc_ns == 'nested' )  THEN
+             nest_bound_n = .TRUE.
+          ENDIF
+       ENDIF
+    ENDIF
+       
 !
 !-- Broadcast the id of the inflow PE
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1932)
+++ palm/trunk/SOURCE/palm.f90	(revision 1933)
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1834 2016-04-07 14:34:20Z raasch
+! Initial version of purely vertical nesting introduced. 
+! 
 ! 1833 2016-04-07 14:23:03Z raasch
 ! required user interface version changed
@@ -134,6 +137,6 @@
         ONLY:  constant_diffusion, coupling_char, coupling_mode,               &
                do2d_at_begin, do3d_at_begin, humidity, io_blocks, io_group,    &
-               large_scale_forcing, message_string, nest_domain, nudging,      &
-               passive_scalar, simulated_time, simulated_time_chr,             &
+               large_scale_forcing, message_string, nest_domain, neutral,      &
+               nudging, passive_scalar, simulated_time, simulated_time_chr,    &
                user_interface_current_revision,                                &
                user_interface_required_revision, version, wall_heatflux,       &
@@ -168,6 +171,6 @@
 
     USE pmc_interface,                                                         &
-        ONLY:  cpl_id, nested_run, pmci_client_initialize, pmci_init,          &
-               pmci_modelconfiguration, pmci_server_initialize
+        ONLY:  cpl_id, nested_run, pmci_child_initialize, pmci_init,           &
+               pmci_modelconfiguration, pmci_parent_initialize
 
     USE statistics,                                                            &
@@ -341,11 +344,11 @@
        CALL pmci_modelconfiguration
 !
-!--    Receive and interpolate initial data on client.
-!--    Client initialization must be made first if the model is both client and
-!--    server
-       CALL pmci_client_initialize
-!
-!--    Send initial condition data from server to client
-       CALL pmci_server_initialize
+!--    Receive and interpolate initial data on children.
+!--    Child initialization must be made first if the model is both child and
+!--    parent
+       CALL pmci_child_initialize
+!
+!--    Send initial condition data from parent to children
+       CALL pmci_parent_initialize
 !
 !--    Exchange_horiz is needed after the nest initialization
@@ -354,5 +357,7 @@
           CALL exchange_horiz( v, nbgp )
           CALL exchange_horiz( w, nbgp )
-          CALL exchange_horiz( pt, nbgp )
+          IF ( .NOT. neutral )  THEN
+             CALL exchange_horiz( pt, nbgp )
+          ENDIF
           IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
           IF (humidity  .OR.  passive_scalar)  THEN
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1932)
+++ palm/trunk/SOURCE/parin.f90	(revision 1933)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! 
 ! 
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1917 2016-05-27 14:28:12Z witha
+! Initial version of purely vertical nesting introduced.
+! 
 ! 1914 2016-05-26 14:44:07Z witha
 ! Added call to wind turbine model for reading of &wind_turbine_par
@@ -245,5 +248,5 @@
 
     USE pmc_interface,                                                         &
-        ONLY:  nested_run
+        ONLY:  nested_run, nesting_mode
 
     USE profil_parameter,                                                      &
@@ -429,14 +432,36 @@
 
 !
-!--       In case of nested runs, explicitly set nesting boundary conditions
-!--       except for the root domain. This will overwrite the user settings.
-          IF ( nest_domain )  THEN
-             bc_lr   = 'nested'
-             bc_ns   = 'nested'
-             bc_uv_t = 'nested'
-             bc_pt_t = 'nested'
-             bc_q_t  = 'nested'
-             bc_p_t  = 'neumann'
+!--       In case of nested runs, explicitly set nesting boundary conditions. 
+!--       This will overwrite the user settings. bc_lr and bc_ns always need
+!--       to be cyclic for vertical nesting.
+          IF ( nesting_mode == 'vertical' )  THEN
+             IF (bc_lr /= 'cyclic' .OR. bc_ns /= 'cyclic' )  THEN
+                WRITE ( message_string, *)  'bc_lr and bc_ns were set to ,',   &
+                                      'cyclic for vertical nesting'
+                CALL message( 'parin', 'PA0428', 0, 0, 0, 6, 0 )
+                bc_lr   = 'cyclic'
+                bc_ns   = 'cyclic'
+             ENDIF
+             IF ( nest_domain )  THEN
+                bc_uv_t = 'nested'
+                bc_pt_t = 'nested'
+                bc_q_t  = 'nested'
+                bc_p_t  = 'neumann'
+             ENDIF
+          ELSE
+          
+!
+!--       For other nesting modes only set boundary conditions for 
+!--       nested domains.
+             IF ( nest_domain )  THEN
+                bc_lr   = 'nested'
+                bc_ns   = 'nested'
+                bc_uv_t = 'nested'
+                bc_pt_t = 'nested'
+                bc_q_t  = 'nested'
+                bc_p_t  = 'neumann'
+             ENDIF
           ENDIF
+            
 !
 !--       Check validity of lateral boundary conditions. This has to be done
